diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/ms-blogs.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/ms-blogs.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/ms-blogs.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/ms-blogs.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 84,111 ****
  }
  
  /**
!  * Given a blog's (subdomain or directory) name, retrieve it's id.
   *
   * @since MU
   *
!  * @param string $name
   * @return int A blog id
   */
! function get_id_from_blogname( $name ) {
  	global $wpdb, $current_site;
! 	$blog_id = wp_cache_get( 'get_id_from_blogname_' . $name, 'blog-details' );
  	if ( $blog_id )
  		return $blog_id;
  
  	if ( is_subdomain_install() ) {
! 		$domain = $name . '.' . $current_site->domain;
  		$path = $current_site->path;
  	} else {
  		$domain = $current_site->domain;
! 		$path = $current_site->path . $name . '/';
  	}
  	$blog_id = $wpdb->get_var( $wpdb->prepare("SELECT blog_id FROM {$wpdb->blogs} WHERE domain = %s AND path = %s", $domain, $path) );
! 	wp_cache_set( 'get_id_from_blogname_' . $name, $blog_id, 'blog-details' );
  	return $blog_id;
  }
  
--- 84,115 ----
  }
  
  /**
!  * Given a blog's (subdomain or directory) slug, retrieve it's id.
   *
   * @since MU
   *
!  * @param string $slug
   * @return int A blog id
   */
! function get_id_from_blogname( $slug ) {
  	global $wpdb, $current_site;
! 
! 	$slug = trim( $slug, '/' );
! 
! 	$blog_id = wp_cache_get( 'get_id_from_blogname_' . $slug, 'blog-details' );
  	if ( $blog_id )
  		return $blog_id;
  
  	if ( is_subdomain_install() ) {
! 		$domain = $slug . '.' . $current_site->domain;
  		$path = $current_site->path;
  	} else {
  		$domain = $current_site->domain;
! 		$path = $current_site->path . $slug . '/';
  	}
+ 
  	$blog_id = $wpdb->get_var( $wpdb->prepare("SELECT blog_id FROM {$wpdb->blogs} WHERE domain = %s AND path = %s", $domain, $path) );
! 	wp_cache_set( 'get_id_from_blogname_' . $slug, $blog_id, 'blog-details' );
  	return $blog_id;
  }
  
***************
*** 114,124 ****
   *
   * @since MU
   *
!  * @param int|string|array $fields A blog ID, a blog name, or an array of fields to query against.
   * @param bool $get_all Whether to retrieve all details or only the details in the blogs table. Default is true.
   * @return object Blog details.
   */
! function get_blog_details( $fields, $get_all = true ) {
  	global $wpdb;
  
  	if ( is_array($fields ) ) {
--- 118,128 ----
   *
   * @since MU
   *
!  * @param int|string|array $fields A blog ID, a blog slug, or an array of fields to query against. Optional. If not specified the current blog ID is used.
   * @param bool $get_all Whether to retrieve all details or only the details in the blogs table. Default is true.
   * @return object Blog details.
   */
! function get_blog_details( $fields = null, $get_all = true ) {
  	global $wpdb;
  
  	if ( is_array($fields ) ) {
***************
*** 162,168 ****
  			return false;
  		}
  	} else {
! 		if ( !is_numeric( $fields ) )
  			$blog_id = get_id_from_blogname( $fields );
  		else
  			$blog_id = $fields;
--- 166,174 ----
  			return false;
  		}
  	} else {
! 		if ( ! $fields )
! 			$blog_id = get_current_blog_id();
! 		elseif ( ! is_numeric( $fields ) )
  			$blog_id = get_id_from_blogname( $fields );
  		else
  			$blog_id = $fields;
***************
*** 222,230 ****
  		return $details;
  	}
  
! 	$details->blogname		= get_blog_option( $blog_id, 'blogname' );
! 	$details->siteurl		= get_blog_option( $blog_id, 'siteurl' );
! 	$details->post_count	= get_blog_option( $blog_id, 'post_count' );
  
  	$details = apply_filters( 'blog_details', $details );
  
--- 228,238 ----
  		return $details;
  	}
  
! 	switch_to_blog( $blog_id );
! 	$details->blogname		= get_option( 'blogname' );
! 	$details->siteurl		= get_option( 'siteurl' );
! 	$details->post_count	= get_option( 'post_count' );
! 	restore_current_blog();
  
  	$details = apply_filters( 'blog_details', $details );
  
***************
*** 247,257 ****
  	$blog_id = (int) $blog_id;
  	$details = get_blog_details( $blog_id, false );
  
! 	wp_cache_delete( $blog_id , 'blog-details' );
! 	wp_cache_delete( $blog_id . 'short' , 'blog-details' );
! 	wp_cache_delete( md5( $details->domain . $details->path )  , 'blog-lookup' );
! 	wp_cache_delete( 'current_blog_' . $details->domain, 'site-options' );
! 	wp_cache_delete( 'current_blog_' . $details->domain . $details->path, 'site-options' );
  
  	do_action( 'refresh_blog_details', $blog_id );
  }
--- 255,261 ----
  	$blog_id = (int) $blog_id;
  	$details = get_blog_details( $blog_id, false );
  
! 	clean_blog_cache( $details );
  
  	do_action( 'refresh_blog_details', $blog_id );
  }
***************
*** 288,305 ****
  	foreach ( array_intersect( array_keys( $details ), $fields ) as $field )
  		$update_details[$field] = $details[$field];
  
! 	$wpdb->update( $wpdb->blogs, $update_details, array('blog_id' => $blog_id) );
  
  	// If spam status changed, issue actions.
  	if ( $details[ 'spam' ] != $current_details[ 'spam' ] ) {
  		if ( $details[ 'spam' ] == 1 )
! 			do_action( "make_spam_blog", $blog_id );
  		else
! 			do_action( "make_ham_blog", $blog_id );
  	}
  
! 	if ( isset($details[ 'public' ]) )
! 		update_blog_option( $blog_id, 'blog_public', $details[ 'public' ] );
  
  	refresh_blog_details($blog_id);
  
--- 292,339 ----
  	foreach ( array_intersect( array_keys( $details ), $fields ) as $field )
  		$update_details[$field] = $details[$field];
  
! 	$result = $wpdb->update( $wpdb->blogs, $update_details, array('blog_id' => $blog_id) );
! 
! 	if ( false === $result )
! 		return false;
  
  	// If spam status changed, issue actions.
  	if ( $details[ 'spam' ] != $current_details[ 'spam' ] ) {
  		if ( $details[ 'spam' ] == 1 )
! 			do_action( 'make_spam_blog', $blog_id );
  		else
! 			do_action( 'make_ham_blog', $blog_id );
  	}
  
! 	// If mature status changed, issue actions.
! 	if ( $details[ 'mature' ] != $current_details[ 'mature' ] ) {
! 		if ( $details[ 'mature' ] == 1 )
! 			do_action( 'mature_blog', $blog_id );
! 		else
! 			do_action( 'unmature_blog', $blog_id );
! 	}
! 
! 	// If archived status changed, issue actions.
! 	if ( $details[ 'archived' ] != $current_details[ 'archived' ] ) {
! 		if ( $details[ 'archived' ] == 1 )
! 			do_action( 'archive_blog', $blog_id );
! 		else
! 			do_action( 'unarchive_blog', $blog_id );
! 	}
! 
! 	// If deleted status changed, issue actions.
! 	if ( $details[ 'deleted' ] != $current_details[ 'deleted' ] ) {
! 		if ( $details[ 'deleted' ] == 1 )
! 			do_action( 'make_delete_blog', $blog_id );
! 		else
! 			do_action( 'make_undelete_blog', $blog_id );
! 	}
! 
! 	if ( isset( $details[ 'public' ] ) ) {
! 		switch_to_blog( $blog_id );
! 		update_option( 'blog_public', $details[ 'public' ] );
! 		restore_current_blog();
! 	}
  
  	refresh_blog_details($blog_id);
  
***************
*** 307,420 ****
  }
  
  /**
!  * Retrieve option value based on setting name and blog_id.
   *
   * If the option does not exist or does not have a value, then the return value
   * will be false. This is useful to check whether you need to install an option
   * and is commonly used during installation of plugin options and to test
   * whether upgrading is required.
   *
!  * There is a filter called 'blog_option_$option' with the $option being
!  * replaced with the option name. The filter takes two parameters. $value and
!  * $blog_id. It returns $value.
!  * The 'option_$option' filter in get_option() is not called.
   *
   * @since MU
-  * @uses apply_filters() Calls 'blog_option_$optionname' with the option name value.
   *
!  * @param int $blog_id Optional. Blog ID, can be null to refer to the current blog.
!  * @param string $setting Name of option to retrieve. Should already be SQL-escaped.
!  * @param string $default (optional) Default value returned if option not found.
   * @return mixed Value set for the option.
   */
! function get_blog_option( $blog_id, $setting, $default = false ) {
! 	global $wpdb;
  
! 	if ( null === $blog_id )
! 		$blog_id = $wpdb->blogid;
  
! 	$key = $blog_id . '-' . $setting . '-blog_option';
! 	$value = wp_cache_get( $key, 'site-options' );
! 	if ( $value == null ) {
! 		if ( $blog_id == $wpdb->blogid ) {
! 			$value = get_option( $setting, $default );
! 			$notoptions = wp_cache_get( 'notoptions', 'options' );
! 			if ( isset( $notoptions[$setting] ) ) {
! 				wp_cache_set( $key, 'noop', 'site-options' );
! 				$value = $default;
! 			} elseif ( $value == false ) {
! 				wp_cache_set( $key, 'falsevalue', 'site-options' );
! 			} else {
! 				wp_cache_set( $key, $value, 'site-options' );
! 			}
! 			return apply_filters( 'blog_option_' . $setting, $value, $blog_id );
! 		} else {
! 			$blog_prefix = $wpdb->get_blog_prefix( $blog_id );
! 			$row = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM {$blog_prefix}options WHERE option_name = %s", $setting ) );
! 			if ( is_object( $row ) ) { // Has to be get_row instead of get_var because of funkiness with 0, false, null values
! 				$value = $row->option_value;
! 				if ( $value == false )
! 					wp_cache_set( $key, 'falsevalue', 'site-options' );
! 				else
! 					wp_cache_set( $key, $value, 'site-options' );
! 			} else { // option does not exist, so we must cache its non-existence
! 				wp_cache_set( $key, 'noop', 'site-options' );
! 				$value = $default;
! 			}
! 		}
! 	} elseif ( $value == 'noop' ) {
! 		$value = $default;
! 	} elseif ( $value == 'falsevalue' ) {
! 		$value = false;
! 	}
! 	// If home is not set use siteurl.
! 	if ( 'home' == $setting && '' == $value )
! 		return get_blog_option( $blog_id, 'siteurl' );
  
! 	if ( 'siteurl' == $setting || 'home' == $setting || 'category_base' == $setting )
! 		$value = untrailingslashit( $value );
  
! 	return apply_filters( 'blog_option_' . $setting, maybe_unserialize( $value ), $blog_id );
  }
  
  /**
!  * Add an option for a particular blog.
   *
   * @since MU
   *
!  * @param int $id The blog id
!  * @param string $key The option key
!  * @param mixed $value The option value
!  * @return bool True on success, false on failure.
   */
! function add_blog_option( $id, $key, $value ) {
  	$id = (int) $id;
  
! 	switch_to_blog($id);
! 	$return = add_option( $key, $value );
  	restore_current_blog();
! 	if ( $return )
! 		wp_cache_set( $id . '-' . $key . '-blog_option', $value, 'site-options' );
  	return $return;
  }
  
  /**
!  * Delete an option for a particular blog.
   *
   * @since MU
   *
!  * @param int $id The blog id
!  * @param string $key The option key
!  * @return bool True on success, false on failure.
   */
! function delete_blog_option( $id, $key ) {
  	$id = (int) $id;
  
! 	switch_to_blog($id);
! 	$return = delete_option( $key );
  	restore_current_blog();
! 	if ( $return )
! 		wp_cache_set( $id . '-' . $key . '-blog_option', '', 'site-options' );
  	return $return;
  }
  
--- 341,455 ----
  }
  
  /**
!  * Clean the blog cache
!  *
!  * @since 3.5.0
!  *
!  * @param stdClass $blog The blog details as returned from get_blog_details()
!  */
! function clean_blog_cache( $blog ) {
! 	$blog_id = $blog->blog_id;
! 	$domain_path_key = md5( $blog->domain . $blog->path );
! 
! 	wp_cache_delete( $blog_id , 'blog-details' );
! 	wp_cache_delete( $blog_id . 'short' , 'blog-details' );
! 	wp_cache_delete(  $domain_path_key, 'blog-lookup' );
! 	wp_cache_delete( 'current_blog_' . $blog->domain, 'site-options' );
! 	wp_cache_delete( 'current_blog_' . $blog->domain . $blog->path, 'site-options' );
! 	wp_cache_delete( 'get_id_from_blogname_' . trim( $blog->path, '/' ), 'blog-details' );
! 	wp_cache_delete( $domain_path_key, 'blog-id-cache' );
! }
! 
! /**
!  * Retrieve option value for a given blog id based on name of option.
   *
   * If the option does not exist or does not have a value, then the return value
   * will be false. This is useful to check whether you need to install an option
   * and is commonly used during installation of plugin options and to test
   * whether upgrading is required.
   *
!  * If the option was serialized then it will be unserialized when it is returned.
   *
   * @since MU
   *
!  * @param int $id A blog ID. Can be null to refer to the current blog.
!  * @param string $option Name of option to retrieve. Expected to not be SQL-escaped.
!  * @param mixed $default Optional. Default value to return if the option does not exist.
   * @return mixed Value set for the option.
   */
! function get_blog_option( $id, $option, $default = false ) {
! 	$id = (int) $id;
  
! 	if ( empty( $id ) )
! 		$id = get_current_blog_id();
  
! 	if ( get_current_blog_id() == $id )
! 		return get_option( $option, $default );
  
! 	switch_to_blog( $id );
! 	$value = get_option( $option, $default );
! 	restore_current_blog();
  
! 	return apply_filters( 'blog_option_' . $option, $value, $id );
  }
  
  /**
!  * Add a new option for a given blog id.
!  *
!  * You do not need to serialize values. If the value needs to be serialized, then
!  * it will be serialized before it is inserted into the database. Remember,
!  * resources can not be serialized or added as an option.
!  *
!  * You can create options without values and then update the values later.
!  * Existing options will not be updated and checks are performed to ensure that you
!  * aren't adding a protected WordPress option. Care should be taken to not name
!  * options the same as the ones which are protected.
   *
   * @since MU
   *
!  * @param int $id A blog ID. Can be null to refer to the current blog.
!  * @param string $option Name of option to add. Expected to not be SQL-escaped.
!  * @param mixed $value Optional. Option value, can be anything. Expected to not be SQL-escaped.
!  * @return bool False if option was not added and true if option was added.
   */
! function add_blog_option( $id, $option, $value ) {
  	$id = (int) $id;
  
! 	if ( empty( $id ) )
! 		$id = get_current_blog_id();
! 
! 	if ( get_current_blog_id() == $id )
! 		return add_option( $option, $value );
! 
! 	switch_to_blog( $id );
! 	$return = add_option( $option, $value );
  	restore_current_blog();
! 
  	return $return;
  }
  
  /**
!  * Removes option by name for a given blog id. Prevents removal of protected WordPress options.
   *
   * @since MU
   *
!  * @param int $id A blog ID. Can be null to refer to the current blog.
!  * @param string $option Name of option to remove. Expected to not be SQL-escaped.
!  * @return bool True, if option is successfully deleted. False on failure.
   */
! function delete_blog_option( $id, $option ) {
  	$id = (int) $id;
  
! 	if ( empty( $id ) )
! 		$id = get_current_blog_id();
! 
! 	if ( get_current_blog_id() == $id )
! 		return delete_option( $option );
! 
! 	switch_to_blog( $id );
! 	$return = delete_option( $option );
  	restore_current_blog();
! 
  	return $return;
  }
  
***************
*** 424,447 ****
   * @since MU
   *
   * @param int $id The blog id
!  * @param string $key The option key
   * @param mixed $value The option value
   * @return bool True on success, false on failrue.
   */
! function update_blog_option( $id, $key, $value, $deprecated = null ) {
  	$id = (int) $id;
  
  	if ( null !== $deprecated  )
  		_deprecated_argument( __FUNCTION__, '3.1' );
  
! 	switch_to_blog($id);
! 	$return = update_option( $key, $value );
  	restore_current_blog();
  
  	refresh_blog_details( $id );
  
- 	if ( $return )
- 		wp_cache_set( $id . '-' . $key . '-blog_option', $value, 'site-options');
  	return $return;
  }
  
--- 459,483 ----
   * @since MU
   *
   * @param int $id The blog id
!  * @param string $option The option key
   * @param mixed $value The option value
   * @return bool True on success, false on failrue.
   */
! function update_blog_option( $id, $option, $value, $deprecated = null ) {
  	$id = (int) $id;
  
  	if ( null !== $deprecated  )
  		_deprecated_argument( __FUNCTION__, '3.1' );
  
! 	if ( get_current_blog_id() == $id )
! 		return update_option( $option, $value );
! 
! 	switch_to_blog( $id );
! 	$return = update_option( $option, $value );
  	restore_current_blog();
  
  	refresh_blog_details( $id );
  
  	return $return;
  }
  
***************
*** 459,526 ****
   * @since MU
   *
   * @param int $new_blog The id of the blog you want to switch to. Default: current blog
!  * @param bool $validate Whether to check if $new_blog exists before proceeding
!  * @return bool	True on success, False if the validation failed
   */
! function switch_to_blog( $new_blog, $validate = false ) {
! 	global $wpdb, $table_prefix, $blog_id, $switched, $switched_stack, $wp_roles, $wp_object_cache;
! 
! 	if ( empty($new_blog) )
! 		$new_blog = $blog_id;
! 
! 	if ( $validate && ! get_blog_details( $new_blog ) )
! 		return false;
  
! 	if ( empty($switched_stack) )
! 		$switched_stack = array();
  
! 	$switched_stack[] = $blog_id;
  
  	/* If we're switching to the same blog id that we're on,
  	* set the right vars, do the associated actions, but skip
  	* the extra unnecessary work */
! 	if ( $blog_id == $new_blog ) {
! 		do_action( 'switch_blog', $blog_id, $blog_id );
! 		$switched = true;
  		return true;
  	}
  
! 	$wpdb->set_blog_id($new_blog);
! 	$table_prefix = $wpdb->prefix;
! 	$prev_blog_id = $blog_id;
! 	$blog_id = $new_blog;
! 
! 	if ( is_object( $wp_roles ) ) {
! 		$wpdb->suppress_errors();
! 		if ( method_exists( $wp_roles ,'_init' ) )
! 			$wp_roles->_init();
! 		elseif ( method_exists( $wp_roles, '__construct' ) )
! 			$wp_roles->__construct();
! 		$wpdb->suppress_errors( false );
  	}
  
! 	if ( did_action('init') ) {
  		$current_user = wp_get_current_user();
! 		if ( is_object( $current_user ) )
! 			$current_user->for_blog( $blog_id );
  	}
  
! 	if ( is_object( $wp_object_cache ) && isset( $wp_object_cache->global_groups ) )
! 		$global_groups = $wp_object_cache->global_groups;
! 	else
! 		$global_groups = false;
! 
! 	wp_cache_init();
! 	if ( function_exists('wp_cache_add_global_groups') ) {
! 		if ( is_array( $global_groups ) )
! 			wp_cache_add_global_groups( $global_groups );
! 		else
! 			wp_cache_add_global_groups( array( 'users', 'userlogins', 'usermeta', 'user_meta', 'site-transient', 'site-options', 'site-lookup', 'blog-lookup', 'blog-details', 'rss', 'global-posts' ) );
! 		wp_cache_add_non_persistent_groups(array( 'comment', 'counts', 'plugins' ));
! 	}
  
- 	do_action('switch_blog', $blog_id, $prev_blog_id);
- 	$switched = true;
  	return true;
  }
  
--- 495,555 ----
   * @since MU
   *
   * @param int $new_blog The id of the blog you want to switch to. Default: current blog
!  * @param bool $deprecated Deprecated argument
!  * @return bool True on success, false if the validation failed
   */
! function switch_to_blog( $new_blog, $deprecated = null ) {
! 	global $wpdb, $wp_roles;
  
! 	if ( empty( $new_blog ) )
! 		$new_blog = $GLOBALS['blog_id'];
  
! 	$GLOBALS['_wp_switched_stack'][] = $GLOBALS['blog_id'];
  
  	/* If we're switching to the same blog id that we're on,
  	* set the right vars, do the associated actions, but skip
  	* the extra unnecessary work */
! 	if ( $new_blog == $GLOBALS['blog_id'] ) {
! 		do_action( 'switch_blog', $new_blog, $new_blog );
! 		$GLOBALS['switched'] = true;
  		return true;
  	}
  
! 	$wpdb->set_blog_id( $new_blog );
! 	$GLOBALS['table_prefix'] = $wpdb->prefix;
! 	$prev_blog_id = $GLOBALS['blog_id'];
! 	$GLOBALS['blog_id'] = $new_blog;
! 
! 	if ( function_exists( 'wp_cache_switch_to_blog' ) ) {
! 		wp_cache_switch_to_blog( $new_blog );
! 	} else {
! 		global $wp_object_cache;
! 
! 		if ( is_object( $wp_object_cache ) && isset( $wp_object_cache->global_groups ) )
! 			$global_groups = $wp_object_cache->global_groups;
! 		else
! 			$global_groups = false;
! 
! 		wp_cache_init();
! 
! 		if ( function_exists( 'wp_cache_add_global_groups' ) ) {
! 			if ( is_array( $global_groups ) )
! 				wp_cache_add_global_groups( $global_groups );
! 			else
! 				wp_cache_add_global_groups( array( 'users', 'userlogins', 'usermeta', 'user_meta', 'site-transient', 'site-options', 'site-lookup', 'blog-lookup', 'blog-details', 'rss', 'global-posts', ' blog-id-cache' ) );
! 			wp_cache_add_non_persistent_groups( array( 'comment', 'counts', 'plugins' ) );
! 		}
  	}
  
! 	if ( did_action( 'init' ) ) {
! 		$wp_roles->reinit();
  		$current_user = wp_get_current_user();
! 		$current_user->for_blog( $new_blog );
  	}
  
! 	do_action( 'switch_blog', $new_blog, $prev_blog_id );
! 	$GLOBALS['switched'] = true;
  
  	return true;
  }
  
***************
*** 530,596 ****
   * @see switch_to_blog()
   * @since MU
   *
!  * @return bool True on success, False if we're already on the current blog
   */
  function restore_current_blog() {
! 	global $table_prefix, $wpdb, $blog_id, $switched, $switched_stack, $wp_roles, $wp_object_cache;
  
! 	if ( !$switched )
  		return false;
  
! 	if ( !is_array( $switched_stack ) )
! 		return false;
  
! 	$blog = array_pop( $switched_stack );
! 	if ( $blog_id == $blog ) {
  		do_action( 'switch_blog', $blog, $blog );
! 		/* If we still have items in the switched stack, consider ourselves still 'switched' */
! 		$switched = ( is_array( $switched_stack ) && count( $switched_stack ) > 0 );
  		return true;
  	}
  
! 	$wpdb->set_blog_id($blog);
! 	$prev_blog_id = $blog_id;
! 	$blog_id = $blog;
! 	$table_prefix = $wpdb->prefix;
! 
! 	if ( is_object( $wp_roles ) ) {
! 		$wpdb->suppress_errors();
! 		if ( method_exists( $wp_roles ,'_init' ) )
! 			$wp_roles->_init();
! 		elseif ( method_exists( $wp_roles, '__construct' ) )
! 			$wp_roles->__construct();
! 		$wpdb->suppress_errors( false );
  	}
  
! 	if ( did_action('init') ) {
  		$current_user = wp_get_current_user();
! 		if ( is_object( $current_user ) )
! 			$current_user->for_blog( $blog_id );
  	}
  
! 	if ( is_object( $wp_object_cache ) && isset( $wp_object_cache->global_groups ) )
! 		$global_groups = $wp_object_cache->global_groups;
! 	else
! 		$global_groups = false;
! 
! 	wp_cache_init();
! 	if ( function_exists('wp_cache_add_global_groups') ) {
! 		if ( is_array( $global_groups ) )
! 			wp_cache_add_global_groups( $global_groups );
! 		else
! 			wp_cache_add_global_groups( array( 'users', 'userlogins', 'usermeta', 'user_meta', 'site-transient', 'site-options', 'site-lookup', 'blog-lookup', 'blog-details', 'rss', 'global-posts' ) );
! 		wp_cache_add_non_persistent_groups(array( 'comment', 'counts', 'plugins' ));
! 	}
  
! 	do_action('switch_blog', $blog_id, $prev_blog_id);
  
- 	/* If we still have items in the switched stack, consider ourselves still 'switched' */
- 	$switched = ( is_array( $switched_stack ) && count( $switched_stack ) > 0 );
  	return true;
  }
  
  /**
   * Check if a particular blog is archived.
   *
   * @since MU
--- 559,633 ----
   * @see switch_to_blog()
   * @since MU
   *
!  * @return bool True on success, false if we're already on the current blog
   */
  function restore_current_blog() {
! 	global $wpdb, $wp_roles;
  
! 	if ( empty( $GLOBALS['_wp_switched_stack'] ) )
  		return false;
  
! 	$blog = array_pop( $GLOBALS['_wp_switched_stack'] );
  
! 	if ( $GLOBALS['blog_id'] == $blog ) {
  		do_action( 'switch_blog', $blog, $blog );
! 		// If we still have items in the switched stack, consider ourselves still 'switched'
! 		$GLOBALS['switched'] = ! empty( $GLOBALS['_wp_switched_stack'] );
  		return true;
  	}
  
! 	$wpdb->set_blog_id( $blog );
! 	$prev_blog_id = $GLOBALS['blog_id'];
! 	$GLOBALS['blog_id'] = $blog;
! 	$GLOBALS['table_prefix'] = $wpdb->prefix;
! 
! 	if ( function_exists( 'wp_cache_switch_to_blog' ) ) {
! 		wp_cache_switch_to_blog( $blog );
! 	} else {
! 		global $wp_object_cache;
! 
! 		if ( is_object( $wp_object_cache ) && isset( $wp_object_cache->global_groups ) )
! 			$global_groups = $wp_object_cache->global_groups;
! 		else
! 			$global_groups = false;
! 
! 		wp_cache_init();
! 
! 		if ( function_exists( 'wp_cache_add_global_groups' ) ) {
! 			if ( is_array( $global_groups ) )
! 				wp_cache_add_global_groups( $global_groups );
! 			else
! 				wp_cache_add_global_groups( array( 'users', 'userlogins', 'usermeta', 'user_meta', 'site-transient', 'site-options', 'site-lookup', 'blog-lookup', 'blog-details', 'rss', 'global-posts', ' blog-id-cache' ) );
! 			wp_cache_add_non_persistent_groups( array( 'comment', 'counts', 'plugins' ) );
! 		}
  	}
  
! 	if ( did_action( 'init' ) ) {
! 		$wp_roles->reinit();
  		$current_user = wp_get_current_user();
! 		$current_user->for_blog( $blog );
  	}
  
! 	do_action( 'switch_blog', $blog, $prev_blog_id );
  
! 	// If we still have items in the switched stack, consider ourselves still 'switched'
! 	$GLOBALS['switched'] = ! empty( $GLOBALS['_wp_switched_stack'] );
  
  	return true;
  }
  
  /**
+  * Determines if switch_to_blog() is in effect
+  *
+  * @since 3.5.0
+  *
+  * @return bool True if switched, false otherwise.
+  */
+ function ms_is_switched() {
+ 	return ! empty( $GLOBALS['_wp_switched_stack'] );
+ }
+ 
+ /**
   * Check if a particular blog is archived.
   *
   * @since MU
***************
*** 632,643 ****
  	if ( null !== $deprecated  )
  		_deprecated_argument( __FUNCTION__, '3.1' );
  
! 	if ( !in_array( $pref, array( 'site_id', 'domain', 'path', 'registered', 'last_updated', 'public', 'archived', 'mature', 'spam', 'deleted', 'lang_id') ) )
  		return $value;
  
! 	$wpdb->update( $wpdb->blogs, array($pref => $value, 'last_updated' => current_time('mysql', true)), array('blog_id' => $blog_id) );
  
! 	refresh_blog_details($blog_id);
  
  	if ( 'spam' == $pref )
  		( $value == 1 ) ? do_action( 'make_spam_blog', $blog_id ) :	do_action( 'make_ham_blog', $blog_id );
--- 669,683 ----
  	if ( null !== $deprecated  )
  		_deprecated_argument( __FUNCTION__, '3.1' );
  
! 	if ( ! in_array( $pref, array( 'site_id', 'domain', 'path', 'registered', 'last_updated', 'public', 'archived', 'mature', 'spam', 'deleted', 'lang_id') ) )
  		return $value;
  
! 	$result = $wpdb->update( $wpdb->blogs, array($pref => $value, 'last_updated' => current_time('mysql', true)), array('blog_id' => $blog_id) );
  
! 	if ( false === $result )
! 		return false;
! 
! 	refresh_blog_details( $blog_id );
  
  	if ( 'spam' == $pref )
  		( $value == 1 ) ? do_action( 'make_spam_blog', $blog_id ) :	do_action( 'make_ham_blog', $blog_id );
***************
*** 645,652 ****
  		( $value == 1 ) ? do_action( 'mature_blog', $blog_id ) : do_action( 'unmature_blog', $blog_id );
  	elseif ( 'archived' == $pref )
  		( $value == 1 ) ? do_action( 'archive_blog', $blog_id ) : do_action( 'unarchive_blog', $blog_id );
! 	elseif ( 'archived' == $pref )
! 		( $value == 1 ) ? do_action( 'archive_blog', $blog_id ) : do_action( 'unarchive_blog', $blog_id );
  
  	return $value;
  }
--- 685,692 ----
  		( $value == 1 ) ? do_action( 'mature_blog', $blog_id ) : do_action( 'unmature_blog', $blog_id );
  	elseif ( 'archived' == $pref )
  		( $value == 1 ) ? do_action( 'archive_blog', $blog_id ) : do_action( 'unarchive_blog', $blog_id );
! 	elseif ( 'deleted' == $pref )
! 		( $value == 1 ) ? do_action( 'make_delete_blog', $blog_id ) : do_action( 'make_undelete_blog', $blog_id );
  
  	return $value;
  }
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/ms-default-constants.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/ms-default-constants.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/ms-default-constants.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/ms-default-constants.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 10,30 ****
  /**
   * Defines Multisite upload constants.
   *
   * @since 3.0.0
   */
! function ms_upload_constants(  ) {
  	global $wpdb;
  
! 	/** @since 3.0.0 */
  	// Base uploads dir relative to ABSPATH
  	if ( !defined( 'UPLOADBLOGSDIR' ) )
  		define( 'UPLOADBLOGSDIR', 'wp-content/blogs.dir' );
  
! 	/** @since 3.0.0 */
! 	if ( !defined( 'UPLOADS' ) ) {
! 		// Uploads dir relative to ABSPATH
  		define( 'UPLOADS', UPLOADBLOGSDIR . "/{$wpdb->blogid}/files/" );
! 		if ( 'wp-content/blogs.dir' == UPLOADBLOGSDIR )
  			define( 'BLOGUPLOADDIR', WP_CONTENT_DIR . "/blogs.dir/{$wpdb->blogid}/files/" );
  	}
  }
--- 10,40 ----
  /**
   * Defines Multisite upload constants.
   *
+  * Exists for backward compatibility with legacy file-serving through
+  * wp-includes/ms-files.php (wp-content/blogs.php in MU).
+  *
   * @since 3.0.0
   */
! function ms_upload_constants() {
  	global $wpdb;
  
! 	// This filter is attached in ms-default-filters.php but that file is not included during SHORTINIT.
! 	add_filter( 'default_site_option_ms_files_rewriting', '__return_true' );
! 
! 	if ( ! get_site_option( 'ms_files_rewriting' ) )
! 		return;
! 
  	// Base uploads dir relative to ABSPATH
  	if ( !defined( 'UPLOADBLOGSDIR' ) )
  		define( 'UPLOADBLOGSDIR', 'wp-content/blogs.dir' );
  
! 	// Note, the main site in a post-MU network uses wp-content/uploads.
! 	// This is handled in wp_upload_dir() by ignoring UPLOADS for this case.
! 	if ( ! defined( 'UPLOADS' ) ) {
  		define( 'UPLOADS', UPLOADBLOGSDIR . "/{$wpdb->blogid}/files/" );
! 
! 		// Uploads dir relative to ABSPATH
! 		if ( 'wp-content/blogs.dir' == UPLOADBLOGSDIR && ! defined( 'BLOGUPLOADDIR' ) )
  			define( 'BLOGUPLOADDIR', WP_CONTENT_DIR . "/blogs.dir/{$wpdb->blogid}/files/" );
  	}
  }
***************
*** 53,59 ****
  	 * @since 2.6.0
  	 */
  	if ( !defined( 'ADMIN_COOKIE_PATH' ) ) {
! 		if( !is_subdomain_install() ) {
  			define( 'ADMIN_COOKIE_PATH', SITECOOKIEPATH );
  		} else {
  			define( 'ADMIN_COOKIE_PATH', SITECOOKIEPATH . 'wp-admin' );
--- 63,69 ----
  	 * @since 2.6.0
  	 */
  	if ( !defined( 'ADMIN_COOKIE_PATH' ) ) {
! 		if ( ! is_subdomain_install() || trim( parse_url( get_option( 'siteurl' ), PHP_URL_PATH ), '/' ) ) {
  			define( 'ADMIN_COOKIE_PATH', SITECOOKIEPATH );
  		} else {
  			define( 'ADMIN_COOKIE_PATH', SITECOOKIEPATH . 'wp-admin' );
***************
*** 74,82 ****
  /**
   * Defines Multisite file constants.
   *
   * @since 3.0.0
   */
! function ms_file_constants(  ) {
  	/**
  	 * Optional support for X-Sendfile header
  	 * @since 3.0.0
--- 84,95 ----
  /**
   * Defines Multisite file constants.
   *
+  * Exists for backward compatibility with legacy file-serving through
+  * wp-includes/ms-files.php (wp-content/blogs.php in MU).
+  *
   * @since 3.0.0
   */
! function ms_file_constants() {
  	/**
  	 * Optional support for X-Sendfile header
  	 * @since 3.0.0
